diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index e3b96734f..974385c5e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -29,16 +29,20 @@ import java.util.Random;
 public class TileEntityFurnace extends TileEntity
         implements Container
 {
-    private final Random random;
+    public static final int SLOT_INGREDIENT = 0;
+    public static final int SLOT_FUEL = 1;
+    public static final int SLOT_RESULT = 2;
+
+    private final Random random = new Random();
+
+    protected ItemStack[] furnaceItemStacks = new ItemStack[3];
+    public int maxBurnTime = 0;
+    public int currentCookTime = 0;
+    public int maxCookTime = 0;
+    public int currentBurnTime = 200;
 
     public TileEntityFurnace()
     {
-        random = new Random();
-        furnaceItemStacks = new ItemStack[3];
-        currentBurnTime = 0;
-        maxBurnTime = 0;
-        currentCookTime = 0;
-        maxCookTime = 200;
     }
 
     @Override
@@ -62,7 +66,7 @@ public class TileEntityFurnace extends TileEntity
             {
                 ItemStack itemstack = furnaceItemStacks[slot];
                 furnaceItemStacks[slot] = null;
-                if (worldObj != null && slot == 2) {
+                if (worldObj != null && slot == SLOT_RESULT) {
                     worldObj.markBlockNeedsUpdate(x, y, z);
                 }
                 return itemstack;
@@ -71,7 +75,7 @@ public class TileEntityFurnace extends TileEntity
             if(furnaceItemStacks[slot].stackSize <= 0)
             {
                 furnaceItemStacks[slot] = null;
-                if (worldObj != null && slot == 2) {
+                if (worldObj != null && slot == SLOT_RESULT) {
                     worldObj.markBlockNeedsUpdate(x, y, z);
                 }
             }
@@ -90,7 +94,7 @@ public class TileEntityFurnace extends TileEntity
         {
             stack.stackSize = getMaxStackSize();
         }
-        if (worldObj != null && slot == 2 && stack == null) {
+        if (worldObj != null && slot == SLOT_RESULT && stack == null) {
             worldObj.markBlockNeedsUpdate(x, y, z);
         }
     }
@@ -180,34 +184,34 @@ public class TileEntityFurnace extends TileEntity
         if(worldObj == null || !worldObj.isClientSide)
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id()) {
-            	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id()) {
-            			furnaceItemStacks[1].stackSize--;
-            			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
+            	if(currentBurnTime == 0 && furnaceItemStacks[SLOT_INGREDIENT] == null) {
+            		if(furnaceItemStacks[SLOT_FUEL] != null && furnaceItemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
+            			furnaceItemStacks[SLOT_FUEL].stackSize--;
+            			if(furnaceItemStacks[SLOT_FUEL].stackSize <= 0) furnaceItemStacks[SLOT_FUEL] = null;
             			updateFurnace(true);
             			furnaceUpdated = true;
             		}
             	}
         	}
         	
-            if(currentBurnTime == 0 && furnaceItemStacks[1] != null && canSmelt())
+            if(currentBurnTime == 0 && furnaceItemStacks[SLOT_FUEL] != null && canSmelt())
             {
-                maxBurnTime = currentBurnTime = getBurnTimeFromItem(furnaceItemStacks[1]);
+                maxBurnTime = currentBurnTime = getBurnTimeFromItem(furnaceItemStacks[SLOT_FUEL]);
                 if(currentBurnTime > 0)
                 {
                     furnaceUpdated = true;
-                    if(furnaceItemStacks[1] != null)
+                    if(furnaceItemStacks[SLOT_FUEL] != null)
                     {
-                        if (furnaceItemStacks[1].getItem() == Items.BUCKET_LAVA)
+                        if (furnaceItemStacks[SLOT_FUEL].getItem() == Items.BUCKET_LAVA)
                         {
-                            furnaceItemStacks[1] = new ItemStack(Items.BUCKET);
+                            furnaceItemStacks[SLOT_FUEL] = new ItemStack(Items.BUCKET);
                         }
                         else
                         {
-                            furnaceItemStacks[1].stackSize--;
-                            if(furnaceItemStacks[1].stackSize <= 0)
+                            furnaceItemStacks[SLOT_FUEL].stackSize--;
+                            if(furnaceItemStacks[SLOT_FUEL].stackSize <= 0)
                             {
-                                furnaceItemStacks[1] = null;
+                                furnaceItemStacks[SLOT_FUEL] = null;
                             }
                         }
                     }
@@ -240,7 +244,7 @@ public class TileEntityFurnace extends TileEntity
 
     private boolean canSmelt()
     {
-        if(furnaceItemStacks[0] == null)
+        if(furnaceItemStacks[SLOT_INGREDIENT] == null)
         {
             return false;
         }
@@ -257,19 +261,19 @@ public class TileEntityFurnace extends TileEntity
         {
             return false;
         }
-        if(furnaceItemStacks[2] == null)
+        if(furnaceItemStacks[SLOT_RESULT] == null)
         {
             return true;
         }
-        if(!furnaceItemStacks[2].isItemEqual(itemstack))
+        if(!furnaceItemStacks[SLOT_RESULT].isItemEqual(itemstack))
         {
             return false;
         }
-        if(furnaceItemStacks[2].stackSize < getMaxStackSize() && furnaceItemStacks[2].stackSize < furnaceItemStacks[2].getMaxStackSize())
+        if(furnaceItemStacks[SLOT_RESULT].stackSize < getMaxStackSize() && furnaceItemStacks[2].stackSize < furnaceItemStacks[SLOT_RESULT].getMaxStackSize())
         {
             return true;
         }
-        return furnaceItemStacks[2].stackSize < itemstack.getMaxStackSize();
+        return furnaceItemStacks[SLOT_RESULT].stackSize < itemstack.getMaxStackSize();
     }
 
     public void smeltItem()
@@ -282,25 +286,25 @@ public class TileEntityFurnace extends TileEntity
         ItemStack itemstack = null;
         for (RecipeEntryFurnace recipeEntryBase : list) {
             if(recipeEntryBase != null){
-                if(recipeEntryBase.matches(furnaceItemStacks[0])){
+                if(recipeEntryBase.matches(furnaceItemStacks[SLOT_INGREDIENT])){
                     itemstack = recipeEntryBase.getOutput();
                 }
             }
         }
-        boolean wasEmpty = furnaceItemStacks[2] == null;
-        if(furnaceItemStacks[2] == null && itemstack != null)
+        boolean wasEmpty = furnaceItemStacks[SLOT_RESULT] == null;
+        if(furnaceItemStacks[SLOT_RESULT] == null && itemstack != null)
         {
-            furnaceItemStacks[2] = itemstack.copy();
-        } else if(furnaceItemStacks[2] != null && itemstack != null && furnaceItemStacks[2].itemID == itemstack.itemID)
+            furnaceItemStacks[SLOT_RESULT] = itemstack.copy();
+        } else if(furnaceItemStacks[SLOT_RESULT] != null && itemstack != null && furnaceItemStacks[SLOT_RESULT].itemID == itemstack.itemID)
         {
-            furnaceItemStacks[2].stackSize += itemstack.stackSize;
+            furnaceItemStacks[SLOT_RESULT].stackSize += itemstack.stackSize;
         }
-        furnaceItemStacks[0].stackSize--;
-        if(furnaceItemStacks[0].stackSize <= 0)
+        furnaceItemStacks[SLOT_INGREDIENT].stackSize--;
+        if(furnaceItemStacks[SLOT_INGREDIENT].stackSize <= 0)
         {
-            furnaceItemStacks[0] = null;
+            furnaceItemStacks[SLOT_INGREDIENT] = null;
         }
-        if (worldObj != null && wasEmpty && furnaceItemStacks[2] != null) {
+        if (worldObj != null && wasEmpty && furnaceItemStacks[SLOT_RESULT] != null) {
             worldObj.markBlockNeedsUpdate(x, y, z);
         }
     }
@@ -372,7 +376,7 @@ public class TileEntityFurnace extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        if (furnaceItemStacks[2] != null) {
+        if (furnaceItemStacks[SLOT_RESULT] != null) {
             return new PacketTileEntityData(this);
         }
         return null;
@@ -406,10 +410,4 @@ public class TileEntityFurnace extends TileEntity
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
     }
-
-    protected ItemStack[] furnaceItemStacks;
-    public int maxBurnTime;
-    public int currentCookTime;
-    public int maxCookTime;
-    public int currentBurnTime;
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index a79f03de4..afa3343fe 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -38,19 +38,26 @@ import java.util.Random;
 public class TileEntityTrommel extends TileEntity
         implements Container
 {
-    public static final int FUEL_SLOT_INDEX = 4;
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    public static final int @NotNull [] SLOTS_INGREDIENT = { 0, 1, 2, 3 };
+    public static final int SLOT_FUEL = 4;
+
+    private static final int MAX_BURN_TIME = 50;
+
+    private final Random random = new Random();
+
+    private ItemStack[] itemStacks = new ItemStack[5];
+
+    public int burnTime = 0;
+    public int currentItemBurnTime = 0;
+    public int itemPopTime = 0;
+    private int nextToSieve = 0;
 
     public TileEntityTrommel()
     {
-        itemStacks = new ItemStack[5];
-        burnTime = 0;
-        currentItemBurnTime = 0;
-        itemPopTime = 0;
-        maxBurnTime = 50;
-        random = new Random();
-        nextToSieve = 1;
 //        for (ItemStack i : trommellableItems){
-//            simulateTrommelDrops(64 , i);
+//            simulateTrommelDrops(64, i);
 //        }
     }
 
@@ -122,7 +129,7 @@ public class TileEntityTrommel extends TileEntity
 
         burnTime = compoundTag.getShort("BurnTime");
         itemPopTime = compoundTag.getShort("CookTime");
-        currentItemBurnTime = getItemBurnTime(itemStacks[FUEL_SLOT_INDEX]);
+        currentItemBurnTime = getItemBurnTime(itemStacks[SLOT_FUEL]);
     }
 
     @Override
@@ -153,14 +160,14 @@ public class TileEntityTrommel extends TileEntity
 
     public float getCookProgressPercent(int i)
     {
-        return ((float)itemPopTime / maxBurnTime) *i;
+        return ((float)itemPopTime / MAX_BURN_TIME) *i;
     }
 
     public int getBurnTimeRemainingScaled(int i)
     {
         if(currentItemBurnTime == 0)
         {
-            currentItemBurnTime = maxBurnTime;
+            currentItemBurnTime = MAX_BURN_TIME;
         }
         return (burnTime * i) / currentItemBurnTime;
     }
@@ -174,8 +181,9 @@ public class TileEntityTrommel extends TileEntity
 	public void tick()
     {
         boolean isClient = worldObj == null ? carriedBlock.holder.world.isClientSide : worldObj.isClientSide;
-        if(nextToSieve > 4)
-            nextToSieve = 1;
+        if(nextToSieve >= SLOTS_INGREDIENT.length) {
+            nextToSieve = 0;
+        }
         boolean isBurning = burnTime > 0;
         boolean flag1 = false;
         if(isBurning)
@@ -185,10 +193,12 @@ public class TileEntityTrommel extends TileEntity
         if(!isClient)
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id()) {
-            	if(currentItemBurnTime == 0 && itemStacks[0] == null && itemStacks[1] == null && itemStacks[2] == null && itemStacks[3] == null) {
-            		if(itemStacks[FUEL_SLOT_INDEX] != null && itemStacks[FUEL_SLOT_INDEX].itemID == Blocks.COBBLE_NETHERRACK.id()) {
-            			itemStacks[FUEL_SLOT_INDEX].stackSize--;
-            			if(itemStacks[FUEL_SLOT_INDEX].stackSize <= 0) itemStacks[FUEL_SLOT_INDEX] = null;
+            	if(currentItemBurnTime == 0 && itemStacks[SLOTS_INGREDIENT[0]] == null && itemStacks[SLOTS_INGREDIENT[1]] == null && itemStacks[SLOTS_INGREDIENT[2]] == null && itemStacks[SLOTS_INGREDIENT[3]] == null) {
+            		if(itemStacks[SLOT_FUEL] != null && itemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
+            			itemStacks[SLOT_FUEL].stackSize--;
+            			if(itemStacks[SLOT_FUEL].stackSize <= 0) {
+                            itemStacks[SLOT_FUEL] = null;
+                        }
             			if (worldObj != null) {
                             BlockLogicTrommel.updateTrommelBlockState(worldObj, new TilePos(x, y, z), true);
                         } else if (carriedBlock != null) {
@@ -198,36 +208,37 @@ public class TileEntityTrommel extends TileEntity
                     }
             	}
         	}
-            if(!canProduce(nextToSieve))
-                nextToSieve = (nextToSieve+1)%4;
-            if(burnTime == 0 && canProduce(nextToSieve))
+            if(!canProduce(SLOTS_INGREDIENT[nextToSieve])) {
+                nextToSieve = (nextToSieve + 1) % SLOTS_INGREDIENT.length;
+            }
+            if(burnTime == 0 && canProduce(SLOTS_INGREDIENT[nextToSieve]))
             {
-                currentItemBurnTime = burnTime = getItemBurnTime(itemStacks[FUEL_SLOT_INDEX]);
+                currentItemBurnTime = burnTime = getItemBurnTime(itemStacks[SLOT_FUEL]);
                 if(burnTime > 0)
                 {
                     flag1 = true;
-                    if(itemStacks[FUEL_SLOT_INDEX] != null)
+                    if(itemStacks[SLOT_FUEL] != null)
                     {
-                    	if(itemStacks[FUEL_SLOT_INDEX].getItem() == Items.BUCKET_LAVA) {
-                    		itemStacks[FUEL_SLOT_INDEX] = new ItemStack(Items.BUCKET);
+                    	if(itemStacks[SLOT_FUEL].getItem() == Items.BUCKET_LAVA) {
+                    		itemStacks[SLOT_FUEL] = new ItemStack(Items.BUCKET);
                     	}else {
-                            itemStacks[FUEL_SLOT_INDEX].stackSize--;
-                            if(itemStacks[FUEL_SLOT_INDEX].stackSize <= 0)
+                            itemStacks[SLOT_FUEL].stackSize--;
+                            if(itemStacks[SLOT_FUEL].stackSize <= 0)
                             {
-                                itemStacks[FUEL_SLOT_INDEX] = null;
+                                itemStacks[SLOT_FUEL] = null;
                             }
                     	}
                     }
                 }
             }
-            if(isBurning() && canProduce(nextToSieve))
+            if(isBurning() && canProduce(SLOTS_INGREDIENT[nextToSieve]))
             {
                 itemPopTime++;
-                if(itemPopTime >= maxBurnTime)
+                if(itemPopTime >= MAX_BURN_TIME)
                 {
                     itemPopTime = 0;
-                    sieveItem(nextToSieve);
-                    nextToSieve = (nextToSieve+1)%4;
+                    sieveItem(SLOTS_INGREDIENT[nextToSieve]);
+                    nextToSieve = (nextToSieve + 1) % SLOTS_INGREDIENT.length;
                     flag1 = true;
                 }
             } else
@@ -551,14 +562,4 @@ public class TileEntityTrommel extends TileEntity
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
     }
-
-    private static final Logger LOGGER = LogUtils.getLogger();
-    private ItemStack[] itemStacks;
-
-    public int burnTime;
-    public int currentItemBurnTime;
-    public int itemPopTime;
-    private final int maxBurnTime;
-    private int nextToSieve;
-    private final Random random;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index 1e70d2221..6cbeeb3fa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -14,6 +14,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DamageType;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
 
 import java.util.*;
 
@@ -34,6 +35,7 @@ public class EntityPainting extends Entity {
         this.direction = 0;
         this.heightOffset = 0.0F;
         this.art = ArtType.Kebab;
+        this.viewScale /= 2;
         setSize(0.5F, 0.5F);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index cc857a6c3..c72f07452 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1509,7 +1509,7 @@ public abstract class Player
         //Find item with lowest stack size in inventory
         int itemSlot = -1;
         int stackSize = -1;
-        for (int i = 0; i < 36; i++) {
+        for (int i = 0; i < ContainerInventory.MAIN_INVENTORY_SIZE; i++) {
             ItemStack stack = this.inventory.getItem(i);
             if (stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata() && stack.getData().equals(selectItem.getData())) {
                 if (stackSize == -1 || stack.stackSize < stackSize) {
@@ -1522,7 +1522,7 @@ public abstract class Player
         if (itemSlot == -1) {
             if (getGamemode() == Gamemodes.CREATIVE) {
                 int emptySlot = -1;
-                for (int i = 0; i < 36; i++) {
+                for (int i = 0; i < ContainerInventory.MAIN_INVENTORY_SIZE; i++) {
                     if (this.inventory.getItem(i) == null) {
                         emptySlot = i;
                         break;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index e8844b635..79e60efb6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -63,7 +63,7 @@ public class ItemDye extends Item {
                 if (!world.isClientSide) {
                     if (world.getBlockType(blockPos.up(queryPos)).lightBlock() <= 2) {
                         @NotNull Block<?> grass = Blocks.GRASS;
-                        if (world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
+                        if (world.getDimensionData().getWorldType().isRetro()) {
                             grass = Blocks.GRASS_RETRO;
                         }
                         world.setBlockTypeNotify(blockPos, grass);
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/ChainText.java b/game/core/src/main/java/net/minecraft/core/lang/text/ChainText.java
index ea357434f..cf2127fbd 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/ChainText.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/ChainText.java
@@ -1,46 +1,46 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.List;
 
-public class ChainText
-    extends Text {
-    private final List<Text> chain = new ArrayList<>();
+public class ChainText extends Text {
+    private final @NotNull List<@NotNull Text> chain = new ArrayList<>();
 
-    ChainText(Text... chain) {
+    public ChainText(final @NotNull Text @NotNull ... chain) {
         this.chain.addAll(Arrays.asList(chain));
     }
 
     @Override
-    void toString(StringBuilder sb) {
-        for (Text text : chain) {
+    void toString(final @NotNull StringBuilder sb) {
+        for (final @NotNull Text text : this.chain) {
             text.toString(sb);
         }
     }
 
     @Override
-    public Text trans(String languageKey) {
+    public @NotNull Text trans(final @NotNull String languageKey) {
         this.chain.add(new TranslatableText(languageKey));
         return this;
     }
 
     @Override
-    public Text func(FunctionText.TextGenerator generator) {
+    public @NotNull Text func(final FunctionText.@NotNull TextGenerator generator) {
         this.chain.add(new FunctionText(generator));
         return this;
     }
 
     @Override
-    public Text lit(String literal) {
+    public @NotNull Text lit(final @NotNull String literal) {
         this.chain.add(new LiteralText(literal));
         return this;
     }
 
     @Override
-    public Text fmt(TextFormatting formatting, Text text) {
+    public @NotNull Text fmt(final @NotNull TextFormatting formatting, final @NotNull Text text) {
         this.chain.add(new FormattedText(formatting, text));
         return this;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/FormattedText.java b/game/core/src/main/java/net/minecraft/core/lang/text/FormattedText.java
index 50e3dbc2c..3bd803569 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/FormattedText.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/FormattedText.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
 
-public class FormattedText
-    extends Text {
-    private final TextFormatting formatting;
-    private final Text text;
+public class FormattedText extends Text {
+    private final @NotNull TextFormatting formatting;
+    private final @NotNull Text text;
 
-    FormattedText(TextFormatting formatting, Text text) {
+    public FormattedText(final @NotNull TextFormatting formatting, final @NotNull Text text) {
         this.formatting = formatting;
         this.text = text;
     }
 
     @Override
-    void toString(StringBuilder sb) {
-        sb.append(formatting.toString());
-        text.toString(sb);
+    void toString(final @NotNull StringBuilder sb) {
+        sb.append(this.formatting);
+        this.text.toString(sb);
         sb.append(TextFormatting.RESET);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/FunctionText.java b/game/core/src/main/java/net/minecraft/core/lang/text/FunctionText.java
index 3454a98ff..aab2f1e44 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/FunctionText.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/FunctionText.java
@@ -1,19 +1,20 @@
 package net.minecraft.core.lang.text;
 
-public class FunctionText
-    extends Text {
-    private final TextGenerator generator;
+import org.jetbrains.annotations.NotNull;
 
-    FunctionText(TextGenerator generator) {
+public class FunctionText extends Text {
+    private final @NotNull TextGenerator generator;
+
+    public FunctionText(final @NotNull TextGenerator generator) {
         this.generator = generator;
     }
 
     @Override
-    void toString(StringBuilder sb) {
-        sb.append(generator.getString());
+    void toString(final @NotNull StringBuilder sb) {
+        this.generator.getText().toString(sb);
     }
 
     public interface TextGenerator {
-        String getString();
+        @NotNull Text getText();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/IntoText.java b/game/core/src/main/java/net/minecraft/core/lang/text/IntoText.java
new file mode 100644
index 000000000..49f23b7e7
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/IntoText.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.lang.text;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface IntoText {
+    @NotNull Text intoText();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/LiteralText.java b/game/core/src/main/java/net/minecraft/core/lang/text/LiteralText.java
index bba248fa7..459bab9d8 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/LiteralText.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/LiteralText.java
@@ -1,15 +1,16 @@
 package net.minecraft.core.lang.text;
 
-public class LiteralText
-    extends Text {
-    private final String literal;
+import org.jetbrains.annotations.NotNull;
 
-    LiteralText(String literal) {
+public class LiteralText extends Text {
+    private final @NotNull String literal;
+
+    public LiteralText(final @NotNull String literal) {
         this.literal = literal;
     }
 
     @Override
-    void toString(StringBuilder sb) {
-        sb.append(literal);
+    void toString(final @NotNull StringBuilder sb) {
+        sb.append(this.literal);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
index d5dfcc64e..a87d79dce 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
@@ -1,38 +1,40 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
 
-public abstract class Text {
-    public static Text text() {
+public abstract class Text implements IntoText {
+    public static @NotNull Text text() {
         return new ChainText();
     }
 
     @Override
-    public String toString() {
-        StringBuilder sb = new StringBuilder();
-        toString(sb);
+    public @NotNull String toString() {
+        final @NotNull StringBuilder sb = new StringBuilder();
+        this.toString(sb);
         return sb.toString();
     }
 
-    abstract void toString(StringBuilder sb);
+    @Override
+    public @NotNull Text intoText() {
+        return this;
+    }
 
-//    public int width(Font font) { // Commented out due to being unused and referencing the client package
-//        return font.getStringWidth(this.toString());
-//    }
+    abstract void toString(@NotNull StringBuilder sb);
 
-    public Text trans(String languageKey) {
+    public @NotNull Text trans(final @NotNull String languageKey) {
         return new ChainText(this, new TranslatableText(languageKey));
     }
 
-    public Text func(FunctionText.TextGenerator generator) {
+    public @NotNull Text func(final FunctionText.@NotNull TextGenerator generator) {
         return new ChainText(this, new FunctionText(generator));
     }
 
-    public Text lit(String literal) {
+    public @NotNull Text lit(final @NotNull String literal) {
         return new ChainText(this, new LiteralText(literal));
     }
 
-    public Text fmt(TextFormatting formatting, Text text) {
+    public @NotNull Text fmt(final @NotNull TextFormatting formatting, final @NotNull Text text) {
         return new ChainText(this, new FormattedText(formatting, text));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/TranslatableText.java b/game/core/src/main/java/net/minecraft/core/lang/text/TranslatableText.java
index b3da433ad..2f72d58ff 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/TranslatableText.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/TranslatableText.java
@@ -1,18 +1,17 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
 
-public class TranslatableText
-    extends Text {
-    private final String languageKey;
+public class TranslatableText extends Text {
+    private final @NotNull String languageKey;
 
-    TranslatableText(String languageKey) {
+    public TranslatableText(final @NotNull String languageKey) {
         this.languageKey = languageKey;
     }
 
     @Override
-    void toString(StringBuilder sb) {
-        sb.append(I18n.getInstance().translateKey(languageKey));
+    void toString(final @NotNull StringBuilder sb) {
+        sb.append(I18n.getInstance().translateKey(this.languageKey));
     }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index ba98d5c82..1123be4bc 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -7,6 +7,7 @@ import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
@@ -22,7 +23,7 @@ import java.util.Objects;
 public class ContainerInventory
     implements Container {
     public static final int MAIN_INVENTORY_SIZE = 36;
-    public static final int ARMOR_INVENTORY_SIZE = 4;
+    public static final int ARMOR_INVENTORY_SIZE = HumanArmorShape.values().length;
     public static final int HOTBAR_SIZE = 9;
 
     private static final int NBT_ARMOR_SLOT_OFFSET = 100;
@@ -334,7 +335,7 @@ public class ContainerInventory
 
     @Override
     public int getContainerSize() {
-        return this.mainInventory.length + 4;
+        return MAIN_INVENTORY_SIZE + ARMOR_INVENTORY_SIZE;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 041b7f075..a79170070 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -25,6 +25,9 @@ import org.slf4j.Logger;
 public abstract class MenuAbstract
 {
 	private static final Logger LOGGER = LogUtils.getLogger();
+
+	public static final int NUM_COLUMNS = 9;
+
 	public List<ItemStack> lastSlots;
 	public List<Slot> slots;
 	public int containerId;
